/**************************************************************************
 * Written By:          Gary T. Desrosiers                                *
 *                      desrosi@pcnet.com                                 *
 *                      http://www.pcnet.com/~desrosi                     *
 *                                                                        *
 * Date:                January 3rd, 1997                                 *
 *                                                                        *
 * Modified:			February 26th, 1997                               *
 *                      Minor bug fixes                                   *
 *                            Home directory not set correctly            *
 *                            Environment variables not expanded          *
 *                                                                        *
 *                      June 23rd, 1997                                   *
 *                      BugFix                                            *
 *                      info3 used after freed in WlxActivateUserShell()  *
 *                                                                        *
 *                      July 10th, 1997                                   *
 *                        More bugfixes, problems in WlxActivateUserShell *
 *                          caused reference to 0x00000000 in non-domain  *
 *                          based workstations.                           * 
 *                        Added bitmaps to dialogs to make it align more  *
 *                          closely with the msgina code.                 *
 *                        Cleaned up the code somewhat.                   *
 *                          Note: I would have liked to put the animated  *
 *                                graphics into this but Microsoft decided*
 *                                to implement them as animated cursors.  *
 *                                I can't seem to convert the frames of   *
 *                                there resource to a .AVI file which is  *
 *                                needed for the animate control.         *
 *                                                                        *
 * Copyright:		    (C) Copyright Gary T. Desrosiers, 1997            *
 *                      All Rights Reserved                               *
 *                                                                        *
 * Description:         Login gina for Windows NT                         *
 *                      Replacement login security module                 *
 *                                                                        *
 * Installation:        To install this dll,                              *
 *                                                                        *
 *  1) Copy gina.dll \winnt\system32                                      *
 *	2) Use regedt32 to add the GinaDLL value to the following key         *
 *                                                                        *
 *HKEY_LOCAL_MACHINE\Software\Microsoft\Windows NT\CurrentVersion\Winlogon* 
 *                                                                        *
 *	Edit+Add Value                                                        *
 *                                                                        *
 *	Value Name:	GinaDLL                                                   *
 *                                                                        *  
 *	Data Type:	REG_SZ                                                    *
 *                                                                        *
 *	String:		gina.dll                                                  *
 *                                                                        *
 *                                                                        *
 *	3)  Reboot                                                            *
 *                                                                        *
 *		To backout, delete the GinaDLL registry entry                     *
 *      This can be done either locally or on another PC in the network   *
 *                                                                        *
 **************************************************************************
*/
#include <windows.h>
#include <commctrl.h>
#include <lm.h>
#include <winwlx.h>
#include "resource.h"
#include <time.h>

typedef struct _GLOBALS {
    HANDLE  hUserToken;
    PWSTR   pszUsername;
    PWSTR   pszDomain;
    PWSTR   pszPassword;
	int		flags;
} GLOBALS, * PGLOBALS;

HINSTANCE                   hDllInstance;
HANDLE                      hGlobalWlx;
PWLX_DISPATCH_VERSION_1_0   pWlxFuncs;

typedef NET_API_STATUS (NET_API_FUNCTION * NUCP)(LPWSTR, LPWSTR, LPWSTR, LPWSTR);
NUCP    NetUserChangePasswordFn = NULL;
HMODULE hNetApi32;
HMODULE hNetMsg = NULL;

int CALLBACK UnlockDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int ErrorMessage(HWND hWnd,PWSTR pszTitleBar,DWORD Buttons);
BOOL LoadNetapi(HWND hDlg);
PWSTR AllocAndCaptureText(HWND hDlg,int Id);
BOOL TryToChangePassword(HWND hDlg,PGLOBALS pGlobals);
int CALLBACK ChangePasswordDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int CALLBACK OptionsDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int ShutdownDialogInit(HWND hDlg,LPARAM lParam);
VOID UpdateShutdownSettings(PGLOBALS pGlobals,DWORD  Setting);
int CALLBACK ShutdownDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int CALLBACK WelcomeDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int CALLBACK WkstaLockedDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int CALLBACK ConfirmLogoffDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
int CALLBACK LogonDlgProc(HWND hDlg,UINT Message,WPARAM wParam,LPARAM lParam);
BOOL LoadDefaults(PGLOBALS pGlobals);
VOID CenterWindow(HWND hwnd);
int AttemptLogon(PGLOBALS pGlobals,PSID pLogonSid,PLUID pLogonId);
PWSTR DupString(PWSTR pszText);
long ModifyEnv(WCHAR *env,WCHAR *name,WCHAR *value,long envSize);
void RevMove(WCHAR *dest,WCHAR *source,long len);
BOOL GetTextualSid(PSID pSid, LPTSTR TextualSid,LPDWORD dwBufferLen);

HINSTANCE                   hDllInstance;   // My instance, for resource loading
HANDLE                      hGlobalWlx;     // Handle to tell winlogon who's calling
PWLX_DISPATCH_VERSION_1_0   pWlxFuncs;      // Ptr to table of functions

#define WINLOGON_APP        TEXT("Winlogon")
#define USERINIT            TEXT("Userinit")
#define USERINIT_DEFAULT    TEXT("Userinit.exe")

WCHAR  szKey[] = TEXT("Software\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon");
WCHAR  szShutdownSettingPath[] = TEXT("Software\\Microsoft\\Windows NT\\CurrentVersion\\Shutdown");


BOOL
WINAPI
DllMain(
    HINSTANCE       hInstance,
    DWORD           dwReason,
    LPVOID          lpReserved)
{
    switch (dwReason)
    {
        case DLL_PROCESS_ATTACH:
            DisableThreadLibraryCalls ( hInstance );
            hDllInstance = hInstance;
			//numbad = 0;
        case DLL_PROCESS_DETACH:
        default:
            return(TRUE);
    }
}

//+---------------------------------------------------------------------------
//  Function:   WlxNegotiate
//
//  Synopsis:   Negotiate version of interface with Winlogon
//
//----------------------------------------------------------------------------
BOOL
WINAPI
WlxNegotiate(
    DWORD                   dwWinlogonVersion,
    PDWORD                  pdwDllVersion
    )
{
    if (dwWinlogonVersion < WLX_CURRENT_VERSION)
    {
        return(FALSE);
    }

    *pdwDllVersion = WLX_CURRENT_VERSION;


    return(TRUE);

}


//+---------------------------------------------------------------------------
//
//  Function:   WlxInitialize
//
//  Synopsis:   Initialize entrypoint from winlogon
//
//----------------------------------------------------------------------------
BOOL
WINAPI
WlxInitialize(
    LPWSTR                  lpWinsta,
    HANDLE                  hWlx,
    PVOID                   pvReserved,
    PVOID                   pWinlogonFunctions,
    PVOID                   *pWlxContext
    )
{
    PGLOBALS  pGlobals;

    pWlxFuncs = (PWLX_DISPATCH_VERSION_1_0) pWinlogonFunctions;

    hGlobalWlx = hWlx;

    pGlobals = LocalAlloc(LMEM_FIXED | LMEM_ZEROINIT, sizeof(GLOBALS));
    pGlobals->pszUsername = LocalAlloc(LMEM_FIXED, 512);
    pGlobals->pszDomain = LocalAlloc(LMEM_FIXED, 512);
    pGlobals->pszPassword = LocalAlloc(LMEM_FIXED, 512);
    *pWlxContext = (PVOID) pGlobals;

    //
    // Read from registry...
    //

    pWlxFuncs->WlxUseCtrlAltDel(hWlx);

    InitCommonControls();

    return(TRUE);
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxDisplaySASNotice
//
//  Synopsis:   Where we display the welcome, we're waiting dialog box
//
//----------------------------------------------------------------------------
VOID
WINAPI
WlxDisplaySASNotice(PVOID   pContext)
{
    int Result;

    Result = pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
                                            hDllInstance,
                                            (LPTSTR) MAKEINTRESOURCE(IDD_WELCOME_DLG),
                                            NULL,
                                            WelcomeDlgProc,
                                            0 );
}

//+---------------------------------------------------------------------------
//
//  Function:   WlxLoggedOutSAS
//
//  Synopsis:   Called when no one logged on...
//
//----------------------------------------------------------------------------
int
WINAPI
WlxLoggedOutSAS(
    PVOID                   pWlxContext,
    DWORD                   dwSasType,
    PLUID                   pAuthenticationId,
    PSID                    pLogonSid,
    PDWORD                  pdwOptions,
    PHANDLE                 phToken,
    PWLX_MPR_NOTIFY_INFO    pMprNotifyInfo,
    PVOID *                 pProfile
    )
{
    int         result;
    PGLOBALS    pGlobals;

    pGlobals = (PGLOBALS) pWlxContext;

    result = pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
                                            hDllInstance,
                                            (LPTSTR) MAKEINTRESOURCE(IDD_LOGON_DLG),
                                            NULL,
                                            LogonDlgProc,
                                            (LPARAM) pGlobals );

    if (result == WLX_SAS_ACTION_LOGON)
    {
        result = AttemptLogon(pGlobals,pLogonSid,pAuthenticationId);
        if (result == WLX_SAS_ACTION_LOGON)
        {
            *pdwOptions = 0;
            *phToken = pGlobals->hUserToken;
            *pProfile = NULL;

            pMprNotifyInfo->pszUserName = DupString(pGlobals->pszUsername);
            pMprNotifyInfo->pszDomain = DupString(pGlobals->pszDomain);
            pMprNotifyInfo->pszPassword = DupString(pGlobals->pszPassword);
            pMprNotifyInfo->pszOldPassword = NULL;
			return(WLX_SAS_ACTION_LOGON);
        } else {
			if(result == ERROR_PASSWORD_MUST_CHANGE) 
				pWlxFuncs->WlxDialogBoxParam(   hGlobalWlx,
						                        hDllInstance,
								                (LPTSTR) MAKEINTRESOURCE(IDD_CHANGE_PASSWORD),
										        NULL,
										  	    ChangePasswordDlgProc,
										        (LONG) pGlobals);

		}
    }
	if((result >= WLX_SAS_ACTION_LOGON) && (result <= WLX_SAS_ACTION_SHUTDOWN_REBOOT))
		return(result);
	else
		return(WLX_SAS_ACTION_NONE);
}

//+---------------------------------------------------------------------------
//
//  Function:   WlxActivateUserShell
//
//  Synopsis:   Activates progman or whatever for the user
//
//----------------------------------------------------------------------------
BOOL
WINAPI
WlxActivateUserShell(
    PVOID                   pWlxContext,
    PWSTR                   pszDesktop,
    PWSTR                   pszMprLogonScript,
    WCHAR*                  pEnvironment
    )
{
    WCHAR       szText[MAX_PATH];
    PWSTR       pszScan;
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    PGLOBALS    pGlobals;
    DWORD       StartCount;

	long envSize;
	WCHAR name[256];
	WCHAR script[MAX_PATH];
	DWORD namesize;
	DWORD type;
	DWORD valuesize;
	HKEY key;
	WCHAR *value;
	WCHAR *valuexp;
	WCHAR *env;
	int i;
	DWORD sizeTextSID;
	WCHAR TextSID[256];
	TOKEN_USER ptgUser[256];
	DWORD cbBuffer;
	
	USER_INFO_3 *info3;
	WCHAR *DomainControllerComputerName;
	NET_API_STATUS status;

    pGlobals = (PGLOBALS) pWlxContext;



	info3 = NULL;
	if(wcslen(pGlobals->pszDomain)) {
		status = NetGetDCName(NULL,pGlobals->pszDomain,(LPBYTE*)&DomainControllerComputerName);
		if(status == NERR_Success) {
			status = NetUserGetInfo(DomainControllerComputerName,pGlobals->pszUsername,3,(LPBYTE*)&info3);
			if(status == NERR_Success) {
				if(wcslen(info3->usri3_home_dir_drive)) {
					ImpersonateLoggedOnUser(pGlobals->hUserToken);
					WNetAddConnection(info3->usri3_home_dir,NULL,info3->usri3_home_dir_drive);
					RevertToSelf();
				} 
			} 
			NetApiBufferFree(DomainControllerComputerName);
		} 
	} else 	NetUserGetInfo(NULL,pGlobals->pszUsername,3,(LPBYTE*)&info3);

	env = LocalAlloc(LMEM_FIXED|LMEM_ZEROINIT,2*32768);
	value = LocalAlloc(LMEM_FIXED|LMEM_ZEROINIT,2*32768);
	valuexp = LocalAlloc(LMEM_FIXED|LMEM_ZEROINIT,2*32768);

	if(env && value && valuexp) {
		envSize = 0;
		while(wcslen(&pEnvironment[envSize]) > 0) {
				wcscpy(&env[envSize],&pEnvironment[envSize]);
				envSize += wcslen(&pEnvironment[envSize])+1;
		}
		cbBuffer = 256;
		GetTokenInformation(pGlobals->hUserToken,TokenUser,ptgUser,cbBuffer,&cbBuffer);
 		sizeTextSID = 256;
		GetTextualSid(ptgUser->User.Sid,TextSID,&sizeTextSID);
		wcscat(TextSID,TEXT("\\Environment"));
		if(RegOpenKey(HKEY_USERS,TextSID,&key) == ERROR_SUCCESS) {
			i = 0;
			valuesize = 512;
			namesize = 256;
			while(RegEnumValue(key,i++,name,&namesize,NULL,&type,(LPBYTE)value,&valuesize) == ERROR_SUCCESS) {
				if(ExpandEnvironmentStrings(value,valuexp,2*32768))
					envSize = ModifyEnv(env,name,valuexp,envSize);
				else
					envSize = ModifyEnv(env,name,value,envSize);
				valuesize = 2*32768;
				namesize = 256;
			}
			if(info3)
				if(wcslen(info3->usri3_home_dir_drive)) {
					envSize = ModifyEnv(env,TEXT("HOMEDRIVE"),info3->usri3_home_dir_drive,envSize);
					envSize = ModifyEnv(env,TEXT("HOMEPATH"),TEXT("\\"),envSize);
				}
			RegCloseKey(key);
		}
	}


    GetProfileString(WINLOGON_APP, USERINIT, USERINIT_DEFAULT, szText, MAX_PATH);
	if(info3) {
		if(info3->usri3_script_path) {
			if(wcslen(info3->usri3_script_path)) {
				if(wcschr(info3->usri3_script_path,':') == NULL) {
					GetWindowsDirectory(script,MAX_PATH);
					wcscat(script,TEXT("\\SYSTEM32\\REPL\\IMPORT\\SCRIPTS\\"));
					wcscat(script,info3->usri3_script_path);
				} else wcscpy(script,info3->usri3_script_path);
				wcscat(szText,TEXT(",")); // just cat the script
				wcscat(szText,script);	  //  at the end of the apps to execute
			}
		}
	}
    StartCount = 0;

    pszScan = wcstok(szText, TEXT(","));
    while (pszScan)
    {
        ZeroMemory(&si, sizeof(si));
        si.cb = sizeof(STARTUPINFO);
        si.lpTitle = pszScan;
        si.dwX = si.dwY = si.dwXSize = si.dwYSize = 0L;
        si.dwFlags = 0;
        si.wShowWindow = SW_SHOW;   // at least let the guy see it
        si.lpReserved2 = NULL;
        si.cbReserved2 = 0;
        si.lpDesktop = pszDesktop;

        ImpersonateLoggedOnUser(pGlobals->hUserToken);

        if (CreateProcessAsUser(pGlobals->hUserToken,   // Token to run as
                            NULL,                   // App name
                            pszScan,                // Command Line
                            NULL,                   // Process SD
                            NULL,                   // Thread SD
                            FALSE,                  // No inherit
                            CREATE_UNICODE_ENVIRONMENT,
                            env == NULL ? pEnvironment : env,
                            NULL,
                            &si,
                            &pi))
        {
            StartCount++;
            CloseHandle(pi.hProcess);
            CloseHandle(pi.hThread);
        }
        RevertToSelf();
        pszScan = wcstok(NULL, TEXT(","));
    }

	if(info3)
		NetApiBufferFree(info3);
	if(env)
		LocalFree(env);
	if(value)
		LocalFree(value);
	if(valuexp)
		LocalFree(valuexp);

    return(StartCount > 0);
}

BOOL GetTextualSid(PSID pSid,LPTSTR TextualSid,LPDWORD dwBufferLen)
{
    PSID_IDENTIFIER_AUTHORITY psia;
    DWORD dwSubAuthorities;
    DWORD dwSidRev=SID_REVISION;
    DWORD dwCounter;
    DWORD dwSidSize;
 
    if(!IsValidSid(pSid))
		return FALSE;
    psia=GetSidIdentifierAuthority(pSid);
    dwSubAuthorities=*GetSidSubAuthorityCount(pSid);
    dwSidSize=(15 + 12 + (12 * dwSubAuthorities) + 1) * sizeof(TCHAR);
    if (*dwBufferLen < dwSidSize)
    {
        *dwBufferLen = dwSidSize;
        SetLastError(ERROR_INSUFFICIENT_BUFFER);
        return FALSE;
    }
    dwSidSize=wsprintf(TextualSid, TEXT("S-%lu-"), dwSidRev );
    if ( (psia->Value[0] != 0) || (psia->Value[1] != 0) )
    {
        dwSidSize+=wsprintf(TextualSid + lstrlen(TextualSid),
                    TEXT("0x%02hx%02hx%02hx%02hx%02hx%02hx"),
                    (USHORT)psia->Value[0],
                    (USHORT)psia->Value[1],
                    (USHORT)psia->Value[2],
                    (USHORT)psia->Value[3],
                    (USHORT)psia->Value[4],
                    (USHORT)psia->Value[5]);
    }
    else
    {
        dwSidSize+=wsprintf(TextualSid + lstrlen(TextualSid),
                    TEXT("%lu"),
                    (ULONG)(psia->Value[5]      )   +
                    (ULONG)(psia->Value[4] <<  8)   +
                    (ULONG)(psia->Value[3] << 16)   +
                    (ULONG)(psia->Value[2] << 24)   );
    }
    for (dwCounter=0 ; dwCounter < dwSubAuthorities ; dwCounter++)
    {
        dwSidSize+=wsprintf(TextualSid + dwSidSize, TEXT("-%lu"),
                    *GetSidSubAuthority(pSid, dwCounter) );
    }
    return TRUE;
}
 



long ModifyEnv(WCHAR *env,WCHAR *name,WCHAR *value,long envSize) {
int s,i;
WCHAR *equal;

i = 0;
while(wcslen(&env[i]) > 0) {
	s = wcslen(&env[i]);
	equal = wcsstr(&env[i],TEXT("="));
	if(equal != NULL) {
		if(_wcsnicmp(name,&env[i],(int)(equal-&env[i])) == 0) {
			RevMove(&env[wcslen(value)+i+s+1],&env[i+s],envSize-i+1);
			wcsncpy(&env[i+s],TEXT(";"),1);
			wcscpy(&env[i+s+1],value);
			return envSize+wcslen(value)+1;

		}
	}
	i += s+1;
}
wcsncpy(&env[i],name,wcslen(name));
wcsncpy(&env[i+wcslen(name)],TEXT("="),1);
wcscpy(&env[i+wcslen(name)+1],value);
return envSize+wcslen(name)+wcslen(value)+2;
}

void RevMove(WCHAR *dest,WCHAR *source,long len) {
int i = len;
	while(i--) {
		dest[i] = source[i];
	}
}
	


//+---------------------------------------------------------------------------
//
//  Function:   WlxLoggedOnSAS
//
//  Synopsis:   Called when someone hits CAD when we're logged on
//
//----------------------------------------------------------------------------
int
WINAPI
WlxLoggedOnSAS(
    PVOID                   pWlxContext,
    DWORD                   dwSasType,
    PVOID                   pReserved
    )
{
    int result = pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
                                            hDllInstance,
                                            (LPTSTR) MAKEINTRESOURCE(IDD_OPTIONS_DLG),
                                            NULL,
                                            OptionsDlgProc,
                                            (LPARAM) pWlxContext );


	if((result >= WLX_SAS_ACTION_LOGON) && (result <= WLX_SAS_ACTION_SHUTDOWN_REBOOT))
		return(result);
	else
		return(WLX_SAS_ACTION_NONE);

}

//+---------------------------------------------------------------------------
//
//  Function:   WlxIsLockOk
//
//  Synopsis:   Called to make sure that locking is ok
//----------------------------------------------------------------------------
BOOL
WINAPI
WlxIsLockOk(
    PVOID                   pWlxContext
    )
{
    return(TRUE);
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxDisplayLockedNotice
//
//  Synopsis:   Displays a notice while the workstation is locked
//
//----------------------------------------------------------------------------
VOID
WINAPI
WlxDisplayLockedNotice(PVOID   pWlxContext)
{
	pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
                                   hDllInstance,
                                   (LPTSTR) MAKEINTRESOURCE(IDD_WKSTA_LOCKED),
                                   NULL,
                                   WkstaLockedDlgProc,
                                   (LPARAM) pWlxContext );
    return;
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxWkstaLockedSAS
//
//  Synopsis:   Responds during an unlock attempt
//
//----------------------------------------------------------------------------
int
WINAPI
WlxWkstaLockedSAS(
    PVOID                   pWlxContext,
    DWORD                   dwSasType
    )
{

	int result = pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
												hDllInstance,
												(LPTSTR) MAKEINTRESOURCE(IDD_UNLOCK_DLG),
												NULL,
												UnlockDlgProc,
												(LPARAM) pWlxContext );
	return(result);
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxIsLogoffOk
//
//  Synopsis:   Called to make sure that logoff is ok
//
//----------------------------------------------------------------------------
BOOL
WINAPI
WlxIsLogoffOk(
    PVOID                   pWlxContext
    )
{
	return(TRUE);
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxLogoff
//
//  Synopsis:   Called when the user logs off
//
//----------------------------------------------------------------------------
VOID
WINAPI
WlxLogoff(
    PVOID                   pWlxContext
    )
{
    PGLOBALS pGlobals;

    pGlobals = (PGLOBALS) pWlxContext;

    //
    // Winlogon has closed it for us..
    //

    pGlobals->hUserToken = NULL;

    return;
}


//+---------------------------------------------------------------------------
//
//  Function:   WlxShutdown
//
//  Synopsis:   Called before shutdown so that we can unload/clean up.
//
//----------------------------------------------------------------------------
VOID
WINAPI
WlxShutdown(
    PVOID                   pWlxContext,
    DWORD                   ShutdownType
    )
{
    return;
}



//+---------------------------------------------------------------------------
//
//  Function:   WkstaLockedDlgProc 
//
//  Synopsis:   Dialog Procedure
//
//----------------------------------------------------------------------------
int
CALLBACK
WkstaLockedDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{


    PGLOBALS    pGlobals;
	WCHAR LogonInfo[255];
	WCHAR ComputerName[MAX_COMPUTERNAME_LENGTH+1];
	DWORD lComputerName;

    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
			pGlobals = (PGLOBALS) lParam;
			CenterWindow(hDlg);
			if(wcslen(pGlobals->pszDomain)) {
				wsprintf(LogonInfo,TEXT("This workstation can only be unlocked by\n%s\\%s or an administrator"),pGlobals->pszDomain,pGlobals->pszUsername);
			} else {
				lComputerName =  MAX_COMPUTERNAME_LENGTH+1;
				GetComputerName(ComputerName,&lComputerName);
				wsprintf(LogonInfo,TEXT("This workstation can only be unlocked by\n%s\\%s or an administrator"),ComputerName,pGlobals->pszUsername);
			}
			SetDlgItemText(hDlg,IDC_LOCK_MSG,LogonInfo);
			return(TRUE);


        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                pWlxFuncs->WlxSasNotify(hGlobalWlx, WLX_SAS_TYPE_CTRL_ALT_DEL);
            }
            return(TRUE);

        default:
            return(FALSE);
    }

}



//+---------------------------------------------------------------------------
//
//  Function:   WelcomeDlgProc 
//
//  Synopsis:   Dialog Procedure
//
//----------------------------------------------------------------------------

int
CALLBACK
WelcomeDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{


    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}


        case WM_INITDIALOG:
			CenterWindow(hDlg);
			return(TRUE);


        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                pWlxFuncs->WlxSasNotify(hGlobalWlx, WLX_SAS_TYPE_CTRL_ALT_DEL);
            }
            return(TRUE);

        default:
            return(FALSE);
    }

}


//----------------------------------------------------------------------------
//
//  Function:   LogonDlgProc
//
//  Synopsis:   Dialog Procedure
//
//----------------------------------------------------------------------------

int
CALLBACK
LogonDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{
	int result;
    PGLOBALS pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);
    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}


        case WM_INITDIALOG: {
			HANDLE hKey;
			DWORD dwType,cbData,Disposition;
			WCHAR ShutdownValue[4];

			CenterWindow(hDlg);
			pGlobals = (PGLOBALS) lParam;
			pGlobals->flags = 0;
			LoadDefaults(pGlobals);
   	        SetFocus(GetDlgItem(hDlg, IDC_USERNAME));
			if(wcslen(pGlobals->pszUsername) > 0) {
				SetDlgItemText(hDlg,IDC_USERNAME,pGlobals->pszUsername);
  			    SetFocus(GetDlgItem(hDlg, IDC_PASSWORD));
			}
			if(wcslen(pGlobals->pszDomain) > 0) {
				SetDlgItemText(hDlg,IDC_DOMAIN,pGlobals->pszDomain);
  			    SetFocus(GetDlgItem(hDlg, IDC_PASSWORD));
			}
			RegCreateKeyEx(HKEY_LOCAL_MACHINE,
                            szKey,
                            0,
                            TEXT(""),
                            REG_OPTION_NON_VOLATILE,
                            KEY_READ,
                            NULL,
                            &hKey,
                            &Disposition);

			cbData = 4;
			RegQueryValueEx(hKey,TEXT("ShutdownWithoutLogon"),0,&dwType,(LPSTR)ShutdownValue,&cbData);
			RegCloseKey(hKey);
			if(wcscmp(ShutdownValue,TEXT("1")) == 0)
				EnableWindow(GetDlgItem(hDlg,IDSHUTDOWN),1);
			else
				EnableWindow(GetDlgItem(hDlg,IDSHUTDOWN),0);
            SetWindowLong(hDlg, GWL_USERDATA, lParam);
            return(FALSE);
			}

        case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDCANCEL: {
					EndDialog(hDlg, WLX_SAS_ACTION_NONE);
 					return(TRUE);
				}

				case IDOK: {
				   GetDlgItemText(hDlg, IDC_USERNAME, pGlobals->pszUsername, 512);
				   GetDlgItemText(hDlg, IDC_PASSWORD, pGlobals->pszPassword, 512);
				   GetDlgItemText(hDlg, IDC_DOMAIN, pGlobals->pszDomain, 512);
				   EndDialog(hDlg, WLX_SAS_ACTION_LOGON);
				   return(TRUE);
				}

				case IDSHUTDOWN: {
						result = pWlxFuncs->WlxDialogBoxParam(hGlobalWlx,
															hDllInstance,
															(LPTSTR) MAKEINTRESOURCE(IDD_SHUTDOWN),
															hDlg,
															ShutdownDlgProc,
															(LONG) pGlobals);
						if (result != WLX_SAS_ACTION_NONE) {
							EndDialog(hDlg, result);
						}
					return(TRUE);
				}

				case IDC_DOMAIN: 
					if(HIWORD(wParam) == CBN_DROPDOWN) 
					{
						DWORD entread,totalent;
						struct _SERVER_INFO_100 *si100; 
						DWORD servertype;
						NET_API_STATUS stat;
						unsigned int i;
						DWORD nulldword = 0;
						if(pGlobals->flags == 0) {
							servertype = SV_TYPE_DOMAIN_ENUM;
							stat = NetServerEnum(NULL,100,(LPBYTE*)&si100,64*sizeof(SERVER_INFO_100),&entread,&totalent,servertype,NULL,&nulldword);
							if(stat == 0) {
 							   pGlobals->flags = 1;
							   for(i = 0;i<entread;i++) 
								  SendDlgItemMessage(hDlg,IDC_DOMAIN,CB_ADDSTRING,0,(LPARAM)si100[i].sv100_name);
								LocalFree(si100);
							}
							return(TRUE);
						}
					}
					break;
            }
			break;

        case WM_CLOSE:
            return(TRUE);

    }

    return(FALSE);
}


int
CALLBACK
UnlockDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{

	WCHAR LogonInfo[256];
	DWORD lComputerName;
	WCHAR ComputerName[MAX_COMPUTERNAME_LENGTH+1];
    
	PGLOBALS pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);

    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
			CenterWindow(hDlg);
			pGlobals = (PGLOBALS) lParam;
			pGlobals->flags = 0;
			if(wcslen(pGlobals->pszDomain)) {
				wsprintf(LogonInfo,TEXT("This workstation can only be unlocked by\n%s\\%s or an administrator"),pGlobals->pszDomain,pGlobals->pszUsername);
			} else {
				lComputerName =  MAX_COMPUTERNAME_LENGTH+1;
				GetComputerName(ComputerName,&lComputerName);
				wsprintf(LogonInfo,TEXT("This workstation can only be unlocked by\n%s\\%s or an administrator"),ComputerName,pGlobals->pszUsername);
			}
			SetDlgItemText(hDlg,IDC_UNLOCK_MSG,LogonInfo);
            SetDlgItemText(hDlg,IDC_USERNAME,pGlobals->pszUsername);
			SetDlgItemText(hDlg,IDC_DOMAIN,pGlobals->pszDomain);
			SetDlgItemText(hDlg,IDC_PASSWORD,TEXT(""));
 	        SetFocus(GetDlgItem(hDlg, IDC_PASSWORD));
            SetWindowLong(hDlg, GWL_USERDATA, lParam);
            return(FALSE);

        case WM_COMMAND: {
			 WCHAR   pszUsername[64];
			 WCHAR   pszDomain[64];
			 WCHAR   pszPassword[64];
			 HANDLE  hUser;

			 switch(LOWORD(wParam)) {
			 case IDCANCEL: {
					EndDialog(hDlg,WLX_SAS_ACTION_NONE);
					return(TRUE);
				}
				
			 case IDOK: {
				   GetDlgItemText(hDlg, IDC_USERNAME, pszUsername, 64);
				   GetDlgItemText(hDlg, IDC_PASSWORD, pszPassword, 64);
				   GetDlgItemText(hDlg, IDC_DOMAIN, pszDomain, 64);

				if (LogonUser(pszUsername,
					  pszDomain,
					  pszPassword,
					  LOGON32_LOGON_INTERACTIVE,
					  LOGON32_PROVIDER_DEFAULT,
					  &hUser)) {
				   CloseHandle(hUser);
				   EndDialog(hDlg,WLX_SAS_ACTION_UNLOCK_WKSTA);
				   } else {
					   CloseHandle(hUser);
					   EndDialog(hDlg,WLX_SAS_ACTION_NONE);
				   }
				}

				case IDC_DOMAIN: 
					if(HIWORD(wParam) == CBN_DROPDOWN) 
					{
					DWORD entread,totalent;
					struct _SERVER_INFO_100 *si100; 
					DWORD servertype;
					NET_API_STATUS stat;
					unsigned int i;
					DWORD nulldword = 0;
					if(pGlobals->flags == 0) {
						servertype = SV_TYPE_DOMAIN_ENUM;
						stat = NetServerEnum(NULL,100,(LPBYTE*)&si100,64*sizeof(SERVER_INFO_100),&entread,&totalent,servertype,NULL,&nulldword);
						if(stat == 0) {
						   pGlobals->flags = 1;
						   for(i = 0;i<entread;i++) 
							  SendDlgItemMessage(hDlg,IDC_DOMAIN,CB_ADDSTRING,0,(LPARAM)si100[i].sv100_name);
							LocalFree(si100);
						}
						return(TRUE);
					}
					}
					break;

            }
			break;

 		}
        break;

        case WM_CLOSE:
            return(TRUE);

    }

    return(FALSE);
}




int
AttemptLogon(PGLOBALS pGlobals,
			 PSID   pLogonSid,
             PLUID  pLogonId)
{
    HANDLE              hUser;
    TOKEN_STATISTICS    TStats;
    TOKEN_GROUPS    *   pGroups;
    DWORD               size;
    DWORD               i;

    if (LogonUser(pGlobals->pszUsername,
                  pGlobals->pszDomain,
                  pGlobals->pszPassword,
                  LOGON32_LOGON_INTERACTIVE,
                  LOGON32_PROVIDER_DEFAULT,
                  &hUser))
    {
        pGlobals->hUserToken = hUser;

        //
        // Now, grovel the token we got back for interesting stuff:
        //

        GetTokenInformation(hUser,
                            TokenStatistics,
                            &TStats,
                            sizeof(TStats),
                            &size);

        *pLogonId = TStats.AuthenticationId;

        pGroups = LocalAlloc(LMEM_FIXED, 1024);

        if (!pGroups)
        {
            CloseHandle(hUser);
            return(WLX_SAS_ACTION_NONE);
        }

        //
        // The tricky part.  We need to get the Logon SID from the token,
        // since that is what Winlogon will use to protect the windowstation
        // and desktop.
        //

        GetTokenInformation(hUser,
                            TokenGroups,
                            pGroups,
                            1024,
                            &size);

        if (size > 1024)
        {
            pGroups = LocalReAlloc(pGroups, LMEM_FIXED, size);
            GetTokenInformation(hUser,
                                TokenGroups,
                                pGroups,
                                size,
                                &size);
        }

        for (i = 0; i < pGroups->GroupCount ; i++)
        {
            if ((pGroups->Groups[i].Attributes & SE_GROUP_LOGON_ID) == SE_GROUP_LOGON_ID)
            {
                CopySid(GetLengthSid(pLogonSid),
                        pLogonSid,
                        pGroups->Groups[i].Sid );
                break;
            }
        }

        LocalFree(pGroups);

        return(WLX_SAS_ACTION_LOGON);
    }

	return(ErrorMessage(NULL, TEXT("Logon Message"), MB_ICONEXCLAMATION | MB_OK));
}

VOID
CenterWindow(
    HWND    hwnd
    )
{
    RECT    rect;
    LONG    dx, dy;
    LONG    dxParent, dyParent;
    LONG    Style;

    // Get window rect
    GetWindowRect(hwnd, &rect);

    dx = rect.right - rect.left;
    dy = rect.bottom - rect.top;

    // Get parent rect
    Style = GetWindowLong(hwnd, GWL_STYLE);
    if ((Style & WS_CHILD) == 0) {

        // Return the desktop windows size (size of main screen)
        dxParent = GetSystemMetrics(SM_CXSCREEN);
        dyParent = GetSystemMetrics(SM_CYSCREEN);
    } else {
        HWND    hwndParent;
        RECT    rectParent;

        hwndParent = GetParent(hwnd);
        if (hwndParent == NULL) {
            hwndParent = GetDesktopWindow();
        }

        GetWindowRect(hwndParent, &rectParent);

        dxParent = rectParent.right - rectParent.left;
        dyParent = rectParent.bottom - rectParent.top;
    }

    // Centre the child in the parent
    rect.left = (dxParent - dx) / 2;
    rect.top  = (dyParent - dy) / 3;

    // Move the child into position
    SetWindowPos(hwnd, HWND_TOPMOST, rect.left, rect.top, 0, 0, SWP_NOSIZE);

    SetForegroundWindow(hwnd);
}

PWSTR
DupString(
    PWSTR   pszText)
{
    PWSTR   New;
    DWORD   cb;

    cb = (wcslen(pszText) + 1) * sizeof(WCHAR);
    New = LocalAlloc(LMEM_FIXED, cb);

    if (New)
    {
        wcscpy(New, pszText);
    }

    return(New);
}



BOOL
LoadDefaults(PGLOBALS pGlobals)
{
    HKEY     hKey;
    DWORD    err;
    PBYTE    pBuffer;
    DWORD    dwType;
    DWORD    cbData;
	DWORD    Disposition;

    wcscpy(pGlobals->pszUsername,TEXT(""));
    wcscpy(pGlobals->pszDomain,TEXT(""));
    wcscpy(pGlobals->pszPassword,TEXT(""));

    err = RegCreateKeyEx(   HKEY_LOCAL_MACHINE,
                            szKey,
                            0,
                            TEXT(""),
                            REG_OPTION_NON_VOLATILE,
                            KEY_WRITE | KEY_READ,
                            NULL,
                            &hKey,
                            &Disposition);

    if (err)
    {
        return(FALSE);
    }

    pBuffer = LocalAlloc(LMEM_FIXED, 512);
    cbData = 512;
    if(RegQueryValueEx(hKey,TEXT("DefaultUserName"),0,&dwType,pBuffer,&cbData) == ERROR_SUCCESS) {
        wcscpy(pGlobals->pszUsername, (WCHAR*)pBuffer);
	}
    cbData = 512;
    if(RegQueryValueEx(hKey,TEXT("DefaultDomainName"),0,&dwType,pBuffer,&cbData) == ERROR_SUCCESS) {
        wcscpy(pGlobals->pszDomain, (WCHAR*)pBuffer);
	}
	RegCloseKey(hKey);
	LocalFree(pBuffer);
    return(TRUE);
}

int
CALLBACK
OptionsDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{
    PGLOBALS    pGlobals;
    int         result;
	WCHAR ComputerName[MAX_COMPUTERNAME_LENGTH+1];
	DWORD lComputerName;
	struct _USER_INFO_2 *ui;
	WCHAR LogonInfo[255];

    pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);

    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
			pGlobals = (PGLOBALS) lParam;
			CenterWindow(hDlg);
			lComputerName =  MAX_COMPUTERNAME_LENGTH+1;
			GetComputerName(ComputerName,&lComputerName);
			wsprintf(LogonInfo,TEXT("You are logged on as %s\\%s"),ComputerName,pGlobals->pszUsername);
			SetDlgItemText(hDlg,IDC_LOGON_NAME,LogonInfo);
			if(NetUserGetInfo(NULL,(LPWSTR)pGlobals->pszUsername,2,(LPBYTE *)&ui) != NERR_Success)
				SetDlgItemText(hDlg,IDC_LOGON_DATE,TEXT("Unknown"));
			else 
				SetDlgItemText(hDlg,IDC_LOGON_DATE,_wctime(&ui->usri2_last_logon));
			SetWindowLong(hDlg, GWL_USERDATA, lParam);
			return(TRUE);

        case WM_COMMAND:
            switch (LOWORD(wParam))
            {
                case IDCANCEL:
                    EndDialog(hDlg, WLX_SAS_ACTION_NONE);
                    return(TRUE);

                case IDB_LOCK_WORKSTATION:
                    EndDialog(hDlg, WLX_SAS_ACTION_LOCK_WKSTA);
                    return(TRUE);

                case IDB_TASK_MANAGER:
                    EndDialog(hDlg, WLX_SAS_ACTION_TASKLIST);
                    return(TRUE);

                case IDB_LOGOFF:
							if(pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
												hDllInstance,
												(LPTSTR) MAKEINTRESOURCE(IDD_LOGOFF_CONFIRM),
												NULL,
												ConfirmLogoffDlgProc,
												(LPARAM) pGlobals ) == TRUE)
								EndDialog(hDlg, WLX_SAS_ACTION_LOGOFF);
					return(TRUE);

                case IDB_SHUTDOWN:
                    result = pWlxFuncs->WlxDialogBoxParam(  hGlobalWlx,
                                                        hDllInstance,
                                                        (LPTSTR) MAKEINTRESOURCE(IDD_SHUTDOWN),
                                                        hDlg,
                                                        ShutdownDlgProc,
                                                        (LONG) pGlobals);
                    if (result != WLX_SAS_ACTION_NONE)
                    {
                        EndDialog(hDlg, result);
                    }
                    return(TRUE);

                case IDB_CHANGE_PASSWORD:
                    pWlxFuncs->WlxDialogBoxParam(   hGlobalWlx,
                                                    hDllInstance,
                                                    (LPTSTR) MAKEINTRESOURCE(IDD_CHANGE_PASSWORD),
                                                    hDlg,
                                                    ChangePasswordDlgProc,
                                                    (LONG) pGlobals);
                    return(TRUE);


            }
    }
    return(FALSE);
}

int
ShutdownDialogInit(
    HWND        hDlg,
    LPARAM      lParam)
{
    PGLOBALS    pGlobals;
    HKEY        hKey;
    DWORD       dwValue;
    DWORD       dwSize;
    DWORD       dwType;
    DWORD       PowerOff;

    pGlobals = (PGLOBALS) lParam;

    SetWindowLong(hDlg, GWL_USERDATA, lParam);

    PowerOff = GetProfileInt(TEXT("Winlogon"), TEXT("PowerDownAfterShutdown"), 0);

    if (pGlobals->hUserToken)
    {
        ImpersonateLoggedOnUser(pGlobals->hUserToken);
    }

    dwValue = 0;

    if (!RegOpenKey(HKEY_CURRENT_USER,
                    szShutdownSettingPath,
                    &hKey))
    {
        dwSize = sizeof(DWORD);
        RegQueryValueEx(hKey, TEXT("Shutdown Setting"), 0, &dwType, (PBYTE) &dwValue, &dwSize);
        RegCloseKey(hKey);
    }

    if (pGlobals->hUserToken)
    {
        RevertToSelf();
    }

    if (!PowerOff)
    {
        ShowWindow(GetDlgItem(hDlg, IDD_CONFIRM_POWEROFF), SW_HIDE);
    }

    if (!pGlobals->hUserToken)
    {
        ShowWindow(GetDlgItem(hDlg, IDD_CONFIRM_LOGOFF), SW_HIDE);
    }

    switch (dwValue)
    {
        case 0:
            if (pGlobals->hUserToken)
            {
                CheckDlgButton(hDlg, IDD_CONFIRM_LOGOFF, 1);
                SetFocus(GetDlgItem(hDlg, IDD_CONFIRM_LOGOFF));
                break;
            }

        case 2:
            CheckDlgButton(hDlg, IDD_CONFIRM_REBOOT, 1);
                SetFocus(GetDlgItem(hDlg, IDD_CONFIRM_REBOOT));
            break;
        case 3:
            if (PowerOff)
            {
                CheckDlgButton(hDlg, IDD_CONFIRM_POWEROFF, 1);
                SetFocus(GetDlgItem(hDlg, IDD_CONFIRM_POWEROFF));
                break;
            }
        default:
            CheckDlgButton(hDlg, IDD_CONFIRM_SHUTDOWN, 1);
            SetFocus(GetDlgItem(hDlg, IDD_CONFIRM_SHUTDOWN));

    }

    CenterWindow(hDlg);

    SetFocus(GetDlgItem(hDlg, IDOK));

    return(1);

}

VOID
UpdateShutdownSettings(
            PGLOBALS    pGlobals,
            DWORD       Setting)
{
    // int err;
    HKEY    hKey;
    DWORD   Actual;

    switch (Setting)
    {
        default:
        case IDD_CONFIRM_LOGOFF:
            Actual = 0;
            break;

        case IDD_CONFIRM_SHUTDOWN:
            Actual = 1;
            break;

        case IDD_CONFIRM_REBOOT:
            Actual = 2;
            break;

        case IDD_CONFIRM_POWEROFF:
            Actual = 3;
            break;
    }


    if (pGlobals->hUserToken)
    {
        ImpersonateLoggedOnUser(pGlobals->hUserToken);
    }

    if (!RegOpenKey(HKEY_CURRENT_USER,
                    szShutdownSettingPath,
                    &hKey))
    {
        RegSetValueEx(  hKey,
                        TEXT("Shutdown Setting"),
                        0,
                        REG_DWORD,
                        (PBYTE) &Actual,
                        sizeof(DWORD) );
        RegCloseKey(hKey);
    }

    if (pGlobals->hUserToken)
    {
        RevertToSelf();
    }

}

int
CALLBACK
ShutdownDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{
    PGLOBALS    pGlobals;

    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
            return(ShutdownDialogInit(hDlg, lParam));

        case WM_COMMAND:
            if (LOWORD(wParam) == IDCANCEL)
            {
                EndDialog(hDlg, WLX_SAS_ACTION_NONE);
            }
            if (LOWORD(wParam) == IDOK)
            {
                pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);

                if (IsDlgButtonChecked(hDlg, IDD_CONFIRM_LOGOFF))
                {
                    UpdateShutdownSettings(pGlobals, IDD_CONFIRM_LOGOFF);
                    EndDialog(hDlg, WLX_SAS_ACTION_LOGOFF);
                }
                else if (IsDlgButtonChecked(hDlg, IDD_CONFIRM_REBOOT))
                {
                    UpdateShutdownSettings(pGlobals, IDD_CONFIRM_REBOOT);
                    EndDialog(hDlg, WLX_SAS_ACTION_SHUTDOWN_REBOOT);
                }
                else if (IsDlgButtonChecked(hDlg, IDD_CONFIRM_POWEROFF))
                {
                    UpdateShutdownSettings(pGlobals, IDD_CONFIRM_POWEROFF);
                    EndDialog(hDlg, WLX_SAS_ACTION_SHUTDOWN_POWER_OFF);
                }
                else
                {
                    UpdateShutdownSettings(pGlobals, IDD_CONFIRM_SHUTDOWN);
                    EndDialog(hDlg, WLX_SAS_ACTION_SHUTDOWN);
                }

            }
            return(TRUE);
    }
    return(FALSE);
}

PWSTR
AllocAndCaptureText(
    HWND    hDlg,
    int     Id)
{
    WCHAR   szTemp[MAX_PATH];
    PWSTR   New;
    DWORD   cb;

    cb = GetDlgItemText(hDlg, Id, szTemp, MAX_PATH);
    New = LocalAlloc(LMEM_FIXED, (cb + 1) * sizeof(WCHAR));
    if (New)
    {
        wcscpy(New, szTemp);
    }
    return(New);
}

BOOL
LoadNetapi(HWND hDlg)
{
    hNetApi32 = LoadLibrary(TEXT("netapi32.dll"));
    if (hNetApi32)
    {
        NetUserChangePasswordFn = (NUCP) GetProcAddress(hNetApi32, "NetUserChangePassword");
        if (NetUserChangePasswordFn)
        {
            return(TRUE);
        }
    }

    ErrorMessage(hDlg, TEXT("Change Password"), MB_ICONSTOP | MB_OK);

    return(FALSE);

}


BOOL
TryToChangePassword(
    HWND        hDlg,
    PGLOBALS    pGlobals)
{
    PWSTR   pszUsername;
    PWSTR   pszDomain;
    PWSTR   pszOld;
    PWSTR   pszNew;
    PWSTR   pszTemp;

    NET_API_STATUS  NetStatus;

    if (!NetUserChangePasswordFn)
    {
        if (!LoadNetapi(hDlg))
        {
            return(FALSE);
        }
    }

    pszUsername = AllocAndCaptureText(hDlg, IDD_USER_NAME);
    pszDomain = AllocAndCaptureText(hDlg, IDD_DOMAIN);
    pszOld = AllocAndCaptureText(hDlg, IDD_OLD_PASSWORD);
    pszNew = AllocAndCaptureText(hDlg, IDD_NEW_PASSWORD);

    if (!pszUsername || !pszDomain || !pszOld || !pszNew)
    {
        goto clean_exit;
    }

    pszTemp = AllocAndCaptureText(hDlg, IDD_CONFIRM_PASSWORD);
    if (wcscmp(pszNew, pszTemp))
    {
        LocalFree(pszTemp);
        MessageBox(hDlg, TEXT("Your passwords did not match."), TEXT("Change Password"),
                        MB_ICONSTOP | MB_OK);
        goto clean_exit;
    }

    NetStatus = NetUserChangePasswordFn(pszDomain, pszUsername, pszOld, pszNew);
    if (NetStatus != NERR_Success)
    {
        SetLastError(NetStatus);
        ErrorMessage(hDlg, TEXT("Change Password"), MB_ICONSTOP | MB_OK);
    }
    else
        MessageBox(hDlg, TEXT("Your password was changed successfully"),
                    TEXT("Change Password"), MB_ICONINFORMATION | MB_OK);

clean_exit:
    if (pszUsername)
    {
        LocalFree(pszUsername);
    }
    if (pszDomain)
    {
        LocalFree(pszDomain);
    }
    if (pszOld)
    {
        LocalFree(pszOld);
    }
    if (pszNew)
    {
        LocalFree(pszNew);
    }

    return(NetStatus == NERR_Success);
}



int
CALLBACK
ChangePasswordDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{
    PGLOBALS    pGlobals;

    pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);
    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
            CenterWindow(hDlg);
            SetWindowLong(hDlg, GWL_USERDATA, lParam);
			pGlobals = (PGLOBALS) lParam;
			pGlobals->flags = 0;
			SetDlgItemText(hDlg,IDD_USER_NAME,pGlobals->pszUsername);
			SetDlgItemText(hDlg,IDD_DOMAIN,pGlobals->pszDomain);
   	        SetFocus(GetDlgItem(hDlg, IDD_OLD_PASSWORD));
            return(FALSE);

        case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK: {
					if (TryToChangePassword(hDlg, pGlobals))
						SetWindowText(GetDlgItem(hDlg, IDCANCEL), TEXT("Done"));
					SetDlgItemText(hDlg, IDD_OLD_PASSWORD, TEXT(""));
					SetDlgItemText(hDlg, IDD_NEW_PASSWORD, TEXT(""));
					SetDlgItemText(hDlg, IDD_CONFIRM_PASSWORD, TEXT(""));
					SetFocus(GetDlgItem(hDlg, IDD_OLD_PASSWORD));
					return(TRUE);
				}

				case IDCANCEL:{
					EndDialog(hDlg, 0);
					return(TRUE);
				}

				case IDD_DOMAIN: 
					if(HIWORD(wParam) == CBN_DROPDOWN) 
					{
					DWORD entread,totalent;
					struct _SERVER_INFO_100 *si100; 
					DWORD servertype;
					NET_API_STATUS stat;
					unsigned int i;
					DWORD nulldword = 0;
					if(pGlobals->flags == 0) {	
						servertype = SV_TYPE_DOMAIN_ENUM;
						stat = NetServerEnum(NULL,100,(LPBYTE*)&si100,64*sizeof(SERVER_INFO_100),&entread,&totalent,servertype,NULL,&nulldword);
						if(stat == 0) {
						   pGlobals->flags = 1;
						   for(i = 0;i<entread;i++) 
							  SendDlgItemMessage(hDlg,IDD_DOMAIN,CB_ADDSTRING,0,(LPARAM)si100[i].sv100_name);
							LocalFree(si100);
						}
						return(TRUE);
					}
					break;
				}
				break;

            }
			break;


    }
    return(FALSE);
}


int
ErrorMessage(
    HWND        hWnd,
    PWSTR       pszTitleBar,
    DWORD       Buttons)
{
    WCHAR   szMessage[256];
    DWORD   GLE;
	WCHAR szTitle[256];

    GLE = GetLastError();
	wsprintf(szTitle,TEXT("%s - %d"),pszTitleBar,GLE);

    if (GLE >= NERR_BASE)
    {
        if (!hNetMsg)
        {
            hNetMsg = LoadLibrary(TEXT("netmsg.dll"));
        }
        FormatMessage(
            FORMAT_MESSAGE_FROM_HMODULE | FORMAT_MESSAGE_IGNORE_INSERTS,
            hNetMsg,                               // ignored
            GLE,                                  // message id
            MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),   // message language
            szMessage,                  // address of buffer pointer
            199,                                  // minimum buffer size
            NULL );                              // no other arguments

    }

    FormatMessage(
            FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL,                               // ignored
            (GetLastError()),                     // message id
            MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),   // message language
            szMessage,                  // address of buffer pointer
            199,                                  // minimum buffer size
            NULL );                              // no other arguments
	MessageBox(hWnd, szMessage, szTitle, Buttons);
    return(GLE);

}


int
CALLBACK
ConfirmLogoffDlgProc(
    HWND        hDlg,
    UINT        Message,
    WPARAM      wParam,
    LPARAM      lParam)
{
    PGLOBALS    pGlobals;

    pGlobals = (PGLOBALS) GetWindowLong(hDlg, GWL_USERDATA);
    switch (Message)
    {
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		case WM_CTLCOLORBTN:
			SetBkColor((HDC)wParam,RGB(192,192,192));
			SetTextColor((HDC)wParam,RGB(0,0,0));
			return((int)CreateSolidBrush(RGB(192,192,192)));

		case WM_PAINT: {
			PAINTSTRUCT ps;
			RECT rect;
			BeginPaint(hDlg,&ps);
			GetClientRect(hDlg,&rect);
			FillRect(ps.hdc,&rect,GetStockObject(LTGRAY_BRUSH));
			EndPaint(hDlg,&ps);
			return(TRUE);
		}

        case WM_INITDIALOG:
            CenterWindow(hDlg);
            return(FALSE);

        case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK: {
					EndDialog(hDlg, TRUE);
					return(TRUE);
				}

				case IDCANCEL:{
					EndDialog(hDlg, FALSE);
					return(TRUE);
				}


            }
			break;

    }
    return(FALSE);
}
